--[[

This file is part of RampageAI.

RampageAI is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

RampageAI is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with RampageAI; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

--]]

-------------------
-- Extra Scripts --
-------------------

--[[ Put any extra scripts as required here

	NOTE: ScriptLocation is the directory where the RampageAI script is stored

Example:

require (ScriptLocation .. "Conf/Custom2.lua")

--]]

require (ScriptLocation .. "Conf/AMCs.lua")

--------------------
-- Custom Globals --
--------------------

--****************--
-- Example Step 1 --
--****************--
--[[
-- Example global variables
ElipseXmod = -2
ElipseYmod = 0
--]]
--*************--
-- Example End --
--*************--


----------------------------------
-- Customization Initialization --
----------------------------------

-- (that has a nice ring to it, wouldn't you say?)

-- Init function
function InitCustom()

--[[

Initialize your customizations here.

Hook or replace functions, and set some settings if you like.

--]]

	-- An example to initialize the Advanced Movement Commands
	InitCustomAMCs()


end


------------------------
-- PVP Initialization --
------------------------

-- This function will >>ONLY<< be called when the homunculus is in a PVP-zone
function InitCustomPVP()
end

-- This function will >>ONLY<< be called when the homunculus is in a WoE-zone
function InitCustomWoE()
end

---------------------
-- Main AI Routine --
---------------------

function CustomAI()

--[[

Place your custom AI routines here. This function gets called
every time the regular AI gets called.

--]]

--****************--
-- Example Step 2 --
--****************--
--[[
	-- Check if we aren't doing anything, we aren't holding a
	-- position, and our owner isn't moving
	if nextseq[1] == SEQ_NONE and not HoldPosition and
		GetV(V_MOTION,OwnerID) ~= MOTION_MOVE then

		-- Calculate the next move
		ElipseXmod = ElipseXmod + ElipseYmod
		ElipseYmod = ElipseYmod - ElipseXmod

		-- Calculate the location
		local x,y = GetV(V_POSITION,OwnerID)
		x=x+ElipseXmod
		y=y+ElipseYmod

		-- Queue the move command
		List.pushright(AI_seq,{ SEQ_MOVE, x, y })
	end
--]]
--*************--
-- Example End --
--*************--

end

----------------------
-- Custom Functions --
----------------------

--[[

Put any extra functions here.

--]]

