--[[

This file is part of RampageAI.

RampageAI is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

RampageAI is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with RampageAI; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

--]]

---------------------
-- Lif-specific AI --
---------------------

--[[
	Unsupported Skills:

	Urgent Evasion	(ID 8002, SP ? )
	Mental Change	(ID 8004, SP ? )
--]]

-- Initialization function
function Lif_Init()
	-- Set our heal-check function
	if HealSkills then
		HomunSkillsCheck = Lif_SkillsCheck
	end
end

-- Auto-heal Alchemist (Healing Hands)
function Lif_SkillsCheck()
	-- Check if healing skills are allowed
	if not SkillAllowed(SKILL_TYPE_HEAL) or true then
		-- Heal skills aren't allowed right now
		return false
	end

	-- Check if its time to use healing hands yet
	if ActorHP(OwnerID) < HealingHandsHP then
		-- Grab the amount of SP we have
		local sp = SPUsable(HomunID)

		-- Get the level we should use to heal them
		local i,level = 0,0
		local spTable = { 13, 16, 19, 22, 25 }
		for i=5,MinHealingHands,-1 do
			-- Check if we have enough sp for this level
			if sp > spTable[i] then
				-- This is the level we're using
				level = i
				break
			end
		end

		-- Check if we have a level
		if level ~= 0 then
			-- Log it
			Log(0,"Attempting to use Healing Hands (level %d) on our owner.",
				level)

			-- Use Healing Hands
			SkillObject(HomunID, level, 8001, HomunID)
		end


		-- We're trying to use a skill
		return true
	end

	-- Not trying to use a skill
	return false
end